﻿using System;
using System.Xml.Serialization;

namespace MobileCarManager.MobileControls.Styles
{
  /// <summary>
  /// Implements the root object of the style data structure. This data structure is
  /// serializable. All styles will be written into or loaded from an XML file.
  /// </summary>
  [XmlRoot("Styles"), Serializable]
  public class Styles
  {
    /// <summary>Constructor.</summary>
    public Styles()
    {
      Button = new ButtonStyle();
      View = new ViewStyle();
    }

    /// <summary>Returns the style of a button.</summary>
    /// <value>Button style.</value>
    [XmlElement("Button")]
    public ButtonStyle Button { get; set; }

    /// <summary>Returns the style of a view.</summary>
    /// <value>View style.</value>
    [XmlElement("View")]
    public ViewStyle View { get; set; }
  }
}
