﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Xml.Serialization;

namespace MobileCarManager.MobileControls.Styles
{
  /// <summary>Implements the style data structure for a view.</summary>
  [Serializable]
  public class ViewStyle
  {
    /// <summary>Constructor.</summary>
    public ViewStyle()
    {
      this.BackgroundGradient = new GradientStyle();
      this.BackgroundGradient.Gradient.Add(Color.Black);
      this.BackgroundGradient.Gradient.Add(Color.DarkGray);
    }

    /// <summary>Returns the gradient of the view background.</summary>
    [XmlElement("BackgroundGradient")]
    public GradientStyle BackgroundGradient { get; set; }
  }
}
